local f = CreateFrame("Frame")
f:SetPoint("TOPLEFT", 450, -75)
f:SetSize(200, 50)
local text = f:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
text:SetPoint("TOPLEFT", 0, 0)
local raiders = {}
local tanks = {}
local healers = {}
local dps = {}
local melee = {}
local ranged = {}
local mobilityDPS = {}
local player = UnitName("player")
local master = ""
local infusions = {
	light = 1, 
	fel = 1,
}
local init = false
RegisterAddonMessagePrefix("EnRT_MOV")
f:RegisterEvent("ENCOUNTER_START")
f:RegisterEvent("UNIT_AURA")
f:RegisterEvent("PLAYER_LOGIN")
f:RegisterEvent("CHAT_MSG_ADDON")
f:SetScript("OnEvent", function(self, event, ...)
	if event == "ENCOUNTER_START" and EnRT_MaidenOfVigilanceEnabled then
		local eID = ...
		if eID == 2052 then
			master = EnRT_GetRaidLeader()
			EnRT_MOV_InitRaid()
		end
	elseif event == "PLAYER_LOGIN" then
		if EnRT_MaidenOfVigilanceEnabled == nil then EnRT_MaidenOfVigilanceEnabled = true end
	elseif event == "CHAT_MSG_ADDON" then
		local prefix, msg, channel, sender = ...
		if prefix == "EnRT_MOV" then
			local data = EnRT_Split(msg)
			local assignment = data[1]
			local lane = data[2]
			local marker = EnRT_GetMarker(data[3])
			if assignment == "STANDBY" then
				text:SetText("\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..data[3]..":20\124t".." YOU ARE STANDBY BETWEEN LANES ON " .. marker .. " SIDE" .. "\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..data[3]..":20\124t")
				text:Show()
				PlaySoundFile("Interface\\AddOns\\EndlessRaidTools\\Sound\\MaidenOfVigilance\\"..assignment..".ogg", "master")
				C_Timer.After(1, function()
					PlaySoundFile("Interface\\AddOns\\EndlessRaidTools\\Sound\\MaidenOfVigilance\\"..marker..".ogg", "master")
				end)
			elseif assignment == "FRONTLINE" then
				text:SetText("\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..data[3]..":20\124t".." YOU ARE THE FRONTLINE IN THE " .. lane .. " LANE ON " .. marker .. "\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..data[3]..":20\124t")
				text:Show()
				PlaySoundFile("Interface\\AddOns\\EndlessRaidTools\\Sound\\MaidenOfVigilance\\"..assignment..".ogg", "master")
				C_Timer.After(1, function()
					PlaySoundFile("Interface\\AddOns\\EndlessRaidTools\\Sound\\MaidenOfVigilance\\"..marker..".ogg", "master")
					C_Timer.After(0.8, function()
						PlaySoundFile("Interface\\AddOns\\EndlessRaidTools\\Sound\\MaidenOfVigilance\\lane.ogg", "master")
					end)
				end)
			elseif assignment == "GOALKEEPER" then
				text:SetText("\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..data[3]..":20\124t".." YOU ARE THE GOALKEEPER IN THE " .. lane .. " LANE ON " .. marker .. "\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..data[3]..":20\124t")
				text:Show()
				PlaySoundFile("Interface\\AddOns\\EndlessRaidTools\\Sound\\MaidenOfVigilance\\"..assignment..".ogg", "master")
				C_Timer.After(1, function()
					PlaySoundFile("Interface\\AddOns\\EndlessRaidTools\\Sound\\MaidenOfVigilance\\"..marker..".ogg", "master")
					C_Timer.After(0.8, function()
						PlaySoundFile("Interface\\AddOns\\EndlessRaidTools\\Sound\\MaidenOfVigilance\\lane.ogg", "master")
					end)
				end)
			end
			C_Timer.After(15, function(self) 
				text:SetText("")
				text:Hide()
			end)
		end
	elseif event == "UNIT_AURA" and player == master and EnRT_MaidenOfVigilanceEnabled then
		local raider = ...
		local raiderName = UnitName(raider)
		if UnitDebuff(raiderName, GetSpellInfo(235213)) and EnRT_MOV_GetInfusion(raiderName) ~= "Light" then -- Light Infusion
			raiders[raiderName].infusion = "light"
		end
		if UnitDebuff(raiderName, GetSpellInfo(235240)) and EnRT_MOV_GetInfusion(raiderName) ~= "Fel" then -- Fel Infusion
			raiders[raiderName].infusion = "fel"
		end
		if UnitDebuff(raiderName, GetSpellInfo(248812)) and not init then -- Stun Blowback
			init = true
			EnRT_MOV_AssignPositions()
			C_Timer.After(20, function()
				init = false
				for i = 1, GetNumGroupMembers() do 
					local raider = "raid".. i
					if GetRaidTargetIndex(raider) then
						SetRaidTarget(raider, 0)
					end
				end
			end)
		end
	end
end)
function EnRT_MOV_InitRaid()
	for i = 1, GetNumGroupMembers() do
		local raider = "raid"..i
		local raiderName = UnitName(raider)
		local role = UnitGroupRolesAssigned(raider)
		local class = select(2, UnitClass(raider))
		if role == "TANK" then
			tanks[#tanks+1] = raiderName
		elseif role == "HEALER" then
			healers[#healers+1] = raiderName
		elseif class == "ROGUE" or class == "DEATHKNIGHT" or class == "DEMONHUNTER" or class == "WARRIOR" or class == "PALADIN" then
			melee[#melee+1] = raiderName
		elseif class == "HUNTER" then
			ranged[#ranged+1] = raiderName
		else
			dps[#dps+1] = raiderName
		end
		if UnitIsConnected(raider) and UnitIsVisible(raider) then
			raiders[raiderName] = {
				infusion = "",
				role = role,
				class = select(2, UnitClass(raider)),
				marker = 0,
				lane = "",
				assignment = "",
				side = ""
			}
		end
	end
end
--[[
	_____________
	_____________

]]
function EnRT_MOV_AssignPositions()
	--Assigning Tanks to middle lane goalkeepers
	for k,v in pairs(infusions) do
		for i,raiderName in pairs(tanks) do
			if raiders[raiderName].infusion == k and not UnitIsDead(raiderName) then
				local invertSide = raiders[raiderName].infusion == "light" and "fel" or "light" -- if the raiders infusion is light then make invert is fel otherwise light
				raiders[raiderName].assignment = "GOALKEEPER"
				raiders[raiderName].lane = "middle"
				raiders[raiderName].side = invertSide
				if invertSide == "light" then
					raiders[raiderName].marker = 6
				elseif invertSide == "fel" then
					raiders[raiderName].marker = 2
				end
				SendAddonMessage("EnRT_MOV", raiders[raiderName].assignment .." "..raiders[raiderName].lane.." "..raiders[raiderName].marker, "WHISPER", raiderName)
				infusions[k] = infusions[k] + 1
			end
		end
	end
	--Assign Healers
	for k,v in pairs(infusions) do
		for i,raiderName in pairs(healers) do
			if raiders[raiderName].infusion == k and infusions[k] <= 3 and not UnitIsDead(raiderName) then
				local invertSide = raiders[raiderName].infusion == "light" and "fel" or "light" -- if the raiders infusion is light then make invert is fel otherwise light
				if infusions[k] == 1 then
					if invertSide == "light" then
						raiders[raiderName].marker = 6
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 2
					end
					raiders[raiderName].lane = "middle"
				elseif infusions[k] == 2 then
					if invertSide == "light" then
						raiders[raiderName].marker = 7
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 3
					end
					raiders[raiderName].lane = "inner"
				elseif infusions[k] == 3 then
					if invertSide == "light" then
						raiders[raiderName].marker = 8
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 5
					end
					raiders[raiderName].lane = "outer"
				end
				raiders[raiderName].assignment = "GOALKEEPER"
				raiders[raiderName].side = invertSide
				SendAddonMessage("EnRT_MOV", raiders[raiderName].assignment .." "..raiders[raiderName].lane.." "..raiders[raiderName].marker, "WHISPER", raiderName)
				infusions[k] = infusions[k] + 1
			elseif raiders[raiderName].infusion == k then
				raiders[raiderName].lane = "BETWEEN"
				raiders[raiderName].assignment = "STANDBY"
				raiders[raiderName].side = k
				if k == "light" then
					raiders[raiderName].marker = 1
				elseif k == "fel" then
					raiders[raiderName].marker = 4
				end
				SendAddonMessage("EnRT_MOV", raiders[raiderName].assignment .." "..raiders[raiderName].lane.." "..raiders[raiderName].marker, "WHISPER", raiderName)
			end
		end
	end
	--Assign Ranged
	for k,v in pairs(infusions) do
		for i, raiderName in pairs(ranged) do
			if raiders[raiderName].infusion == k and infusions[k] <= 6 and not UnitIsDead(raiderName) then
				local invertSide = raiders[raiderName].infusion == "light" and "fel" or "light" -- if the raiders infusion is light then make invert is fel otherwise light
				if infusions[k] == 1 then
					raiders[raiderName].lane = "middle"
					raiders[raiderName].assignment = "GOALKEEPER"
					raiders[raiderName].side = invertSide
					if invertSide == "light" then
						raiders[raiderName].marker = 6
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 2
					end
				elseif infusions[k] == 2 then
					raiders[raiderName].lane = "inner"
					raiders[raiderName].assignment = "GOALKEEPER"
					raiders[raiderName].side = invertSide
					if invertSide == "light" then
						raiders[raiderName].marker = 7
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 3
					end
				elseif infusions[k] == 3 then
					raiders[raiderName].lane = "outer"
					raiders[raiderName].assignment = "GOALKEEPER"
					raiders[raiderName].side = invertSide
					if invertSide == "light" then
						raiders[raiderName].marker = 8
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 5
					end
				elseif infusions[k] == 4 then
					raiders[raiderName].lane = "middle"
					raiders[raiderName].assignment = "FRONTLINE"
					raiders[raiderName].side = k
					if k == "light" then
						raiders[raiderName].marker = 6
						SetRaidTarget(raiderName, 6)
					elseif k == "fel" then
						raiders[raiderName].marker = 2
						SetRaidTarget(raiderName, 2)
					end
				elseif infusions[k] == 5 then
					raiders[raiderName].lane = "inner"
					raiders[raiderName].assignment = "FRONTLINE"
					raiders[raiderName].side = k
					if k == "light" then
						raiders[raiderName].marker = 7
						SetRaidTarget(raiderName, 7)
					elseif k == "fel" then
						raiders[raiderName].marker = 3
						SetRaidTarget(raiderName, 3)
					end
				elseif infusions[k] == 6 then
					raiders[raiderName].lane = "outer"
					raiders[raiderName].assignment = "FRONTLINE"
					raiders[raiderName].side = k
					if k == "light" then
						raiders[raiderName].marker = 8
						SetRaidTarget(raiderName, 8)
					elseif k == "fel" then
						raiders[raiderName].marker = 5
						SetRaidTarget(raiderName, 5)
					end
				end
				SendAddonMessage("EnRT_MOV", raiders[raiderName].assignment .." "..raiders[raiderName].lane.." "..raiders[raiderName].marker, "WHISPER", raiderName)
				infusions[k] = infusions[k] + 1
			elseif raiders[raiderName].infusion == k then
				raiders[raiderName].lane = "BETWEEN"
				raiders[raiderName].assignment = "STANDBY"
				raiders[raiderName].side = k
				if k == "light" then
					raiders[raiderName].marker = 1
				elseif k == "fel" then
					raiders[raiderName].marker = 4
				end
				SendAddonMessage("EnRT_MOV", raiders[raiderName].assignment .." "..raiders[raiderName].lane.." "..raiders[raiderName].marker, "WHISPER", raiderName)
			end
		end
	end
	--Assign Melee
	for k,v in pairs(infusions) do
		for i, raiderName in pairs(melee) do
			if raiders[raiderName].infusion == k and infusions[k] <= 6 and not UnitIsDead(raiderName) then
				local invertSide = raiders[raiderName].infusion == "light" and "fel" or "light" -- if the raiders infusion is light then make invert is fel otherwise light
				if infusions[k] == 1 then
					raiders[raiderName].lane = "middle"
					raiders[raiderName].assignment = "GOALKEEPER"
					raiders[raiderName].side = invertSide
					if invertSide == "light" then
						raiders[raiderName].marker = 6
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 2
					end
				elseif infusions[k] == 2 then
					raiders[raiderName].lane = "inner"
					raiders[raiderName].assignment = "GOALKEEPER"
					raiders[raiderName].side = invertSide
					if invertSide == "light" then
						raiders[raiderName].marker = 7
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 3
					end
				elseif infusions[k] == 3 then
					raiders[raiderName].lane = "outer"
					raiders[raiderName].assignment = "GOALKEEPER"
					raiders[raiderName].side = invertSide
					if invertSide == "light" then
						raiders[raiderName].marker = 8
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 5
					end
				elseif infusions[k] == 4 then
					raiders[raiderName].lane = "middle"
					raiders[raiderName].assignment = "FRONTLINE"
					raiders[raiderName].side = k
					if k == "light" then
						raiders[raiderName].marker = 6
						SetRaidTarget(raiderName, 6)
					elseif k == "fel" then
						raiders[raiderName].marker = 2
						SetRaidTarget(raiderName, 2)
					end
				elseif infusions[k] == 5 then
					raiders[raiderName].lane = "inner"
					raiders[raiderName].assignment = "FRONTLINE"
					raiders[raiderName].side = k
					if k == "light" then
						raiders[raiderName].marker = 7
						SetRaidTarget(raiderName, 7)
					elseif k == "fel" then
						raiders[raiderName].marker = 3
						SetRaidTarget(raiderName, 3)
					end
				elseif infusions[k] == 6 then
					raiders[raiderName].lane = "outer"
					raiders[raiderName].assignment = "FRONTLINE"
					raiders[raiderName].side = k
					if k == "light" then
						raiders[raiderName].marker = 8
						SetRaidTarget(raiderName, 8)
					elseif k == "fel" then
						raiders[raiderName].marker = 5
						SetRaidTarget(raiderName, 5)
					end
				end
				SendAddonMessage("EnRT_MOV", raiders[raiderName].assignment .." "..raiders[raiderName].lane.." "..raiders[raiderName].marker, "WHISPER", raiderName)
				infusions[k] = infusions[k] + 1
			elseif raiders[raiderName].infusion == k then
				raiders[raiderName].lane = "BETWEEN"
				raiders[raiderName].assignment = "STANDBY"
				raiders[raiderName].side = k
				if k == "light" then
					raiders[raiderName].marker = 1
				elseif k == "fel" then
					raiders[raiderName].marker = 4
				end
				SendAddonMessage("EnRT_MOV", raiders[raiderName].assignment .." "..raiders[raiderName].lane.." "..raiders[raiderName].marker, "WHISPER", raiderName)
			end
		end
	end
	--Assign DPS
	for k,v in pairs(infusions) do
		for i, raiderName in pairs(dps) do
			if raiders[raiderName].infusion == k and infusions[k] <= 6 and not UnitIsDead(raiderName) then
				local invertSide = raiders[raiderName].infusion == "light" and "fel" or "light" -- if the raiders infusion is light then make invert is fel otherwise light
				if infusions[k] == 1 then
					raiders[raiderName].lane = "middle"
					raiders[raiderName].assignment = "GOALKEEPER"
					raiders[raiderName].side = invertSide
					if invertSide == "light" then
						raiders[raiderName].marker = 6
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 2
					end
				elseif infusions[k] == 2 then
					raiders[raiderName].lane = "inner"
					raiders[raiderName].assignment = "GOALKEEPER"
					raiders[raiderName].side = invertSide
					if invertSide == "light" then
						raiders[raiderName].marker = 7
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 3
					end
				elseif infusions[k] == 3 then
					raiders[raiderName].lane = "outer"
					raiders[raiderName].assignment = "GOALKEEPER"
					raiders[raiderName].side = invertSide
					if invertSide == "light" then
						raiders[raiderName].marker = 8
					elseif invertSide == "fel" then
						raiders[raiderName].marker = 5
					end
				elseif infusions[k] == 4 then
					raiders[raiderName].lane = "middle"
					raiders[raiderName].assignment = "FRONTLINE"
					raiders[raiderName].side = k
					if k == "light" then
						raiders[raiderName].marker = 6
						SetRaidTarget(raiderName, 6)
					elseif k == "fel" then
						raiders[raiderName].marker = 2
						SetRaidTarget(raiderName, 2)
					end
				elseif infusions[k] == 5 then
					raiders[raiderName].lane = "inner"
					raiders[raiderName].assignment = "FRONTLINE"
					raiders[raiderName].side = k
					if k == "light" then
						raiders[raiderName].marker = 7
						SetRaidTarget(raiderName, 7)
					elseif k == "fel" then
						raiders[raiderName].marker = 3
						SetRaidTarget(raiderName, 3)
					end
				elseif infusions[k] == 6 then
					raiders[raiderName].lane = "outer"
					raiders[raiderName].assignment = "FRONTLINE"
					raiders[raiderName].side = k
					if k == "light" then
						raiders[raiderName].marker = 8
						SetRaidTarget(raiderName, 8)
					elseif k == "fel" then
						raiders[raiderName].marker = 5
						SetRaidTarget(raiderName, 5)
					end
				end
				SendAddonMessage("EnRT_MOV", raiders[raiderName].assignment .." "..raiders[raiderName].lane.." "..raiders[raiderName].marker, "WHISPER", raiderName)
				infusions[k] = infusions[k] + 1
			elseif raiders[raiderName].infusion == k then
				raiders[raiderName].lane = "BETWEEN"
				raiders[raiderName].assignment = "STANDBY"
				raiders[raiderName].side = k
				if k == "light" then
					raiders[raiderName].marker = 1
				elseif k == "fel" then
					raiders[raiderName].marker = 4
				end
				SendAddonMessage("EnRT_MOV", raiders[raiderName].assignment .." "..raiders[raiderName].lane.." "..raiders[raiderName].marker, "WHISPER", raiderName)
			end
		end
	end
end
function EnRT_MOV_GetInfusion(raiderName)
	if raiders[raiderName] then
		return raiders[raiderName].infusion
	end
end
--[[
	Splits the given keyword on each whitespace and stores it in a table
]]
function EnRT_Split(keyword)
	local words = {}
	local count = 1
	for word in keyword:gmatch("%S+") do
		words[count] = word
		count = count + 1
	end
	return words
end
function EnRT_GetMarker(num)
	if num == "1" then return "STAR" end
	if num == "2" then return "CIRCLE" end
	if num == "3" then return "DIAMOND" end
	if num == "4" then return "TRIANGLE" end
	if num == "5" then return "MOON" end
	if num == "6" then return "SQUARE" end
	if num == "7" then return "CROSS" end
	if num == "8" then return "SKULL" end
end